using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

// Our own library
using XNACS1Lib;


namespace SimpleXNA
{
    class BlockSet
    {
        private const float BLOCK_PROBABLITY = 0.3f;

        private List<Block> m_TheSet = null;
        private int m_TotalBreak = 0;

        public BlockSet()
        {
            InitializeBlocks();
        }

        public void InitializeBlocks()
        {
            if (null != m_TheSet)
            {
                for (int c = 0; c < m_TheSet.Count; c++)
                    m_TheSet[c].DeleteBlock();
            }

            m_TotalBreak = 0;
            m_TheSet = new List<Block>();
            int texNum = XNACS1Base.RandomInt(1, 8);
            for (int r = 0; r < 7; r++)
            {
                for (int c = 0; c < 15; c++)
                {
                    if (XNACS1Base.RandomFloat() > BLOCK_PROBABLITY)
                    {
                        float y = (r * 1f) + 8f;
                        float x = (c * 2f) + 0.5f;
                        Block b = new Block(x, y);
                        m_TheSet.Add(b);
                    }
                }
            }
        }

        public void BreakBlocks(Ball ball)
        {
            int c = m_TheSet.Count - 1;
            bool brokeOne = false;

            while ((!brokeOne) && (c >= 0))
            {
                if (m_TheSet[c].CollideWithBall(ball))
                {
                    m_TheSet[c].DeleteBlock();
                    m_TheSet.RemoveAt(c);
                    m_TotalBreak++;
                    brokeOne = true;

                }
                c--;
            }
            XNACS1Base.EchoToTopStatus("Total blocks left:" + m_TheSet.Count + " Total broke:" + m_TotalBreak);
        }
    }
}