
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

// Our own library
using XNACS1Lib;


namespace SimpleXNA
{
    class Paddle : Block
    {
        private const float PADDLE_INIT_POS_X = 15f;
        private const float PADDLE_INIT_POS_Y = 1.2f;

        public Paddle()
            : base(PADDLE_INIT_POS_X, PADDLE_INIT_POS_Y)
        {
            m_Rec.Width *= 2.5f;
            m_Rec.Height *= 0.8f;

            m_Rec.OutsideColor = new Color(250, 120, 120);
            m_Rec.CenterColor = new Color(120, 120, 120);
            m_Rec.Texture = null;
            m_Rec.Label = "Paddle";
            m_Rec.LabelColor = Color.Pink;
            m_Rec.Texture = "paddleTexture";
        }


        public void MovePaddle(float deltaX)
        {
            m_Rec.CenterX += deltaX * 0.2f;
            BoundCollideStatus status = XNACS1Base.World.ClampAtWorldBound(m_Rec);
        }

        public void BounceBall(Ball b)
        {
            if (CollideWithBall(b))
            {
                XNACS1Base.PlayACue("Bounce");
                Vector2 v = b.Velocity;
                v.Y = (float)Math.Abs(v.Y);
                b.Velocity = v;
                
                Vector2 p = b.Position;
                p.Y = m_Rec.MaxBound.Y + b.Radius;
                b.Position = p;
            }
        }
    }
}