using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Content;

namespace BurstABubble_Program
{
    public class PlayingSpace
    {
        private Vector2 m_WorldMin;
        private Vector2 m_WorldMax;
        public Vector2 MinBound { get { return m_WorldMin; } }
        public Vector2 MaxBound { get { return m_WorldMax; } }

        public PlayingSpace(Vector2 min, Vector2 max)
        {
            m_WorldMin = min;
            m_WorldMax = max;
        }

        public bool IsOutOfBounds(Projectile p)
        {
            return ((p.X < m_WorldMin.X) || (p.X > m_WorldMax.X) ||
                    (p.Y < m_WorldMin.Y) || (p.Y > m_WorldMax.Y));
        }
    }
}