using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

// Our own library
using XNACS1Lib;

namespace AlphabetHunt
{
    public class CScoreSystem
    {
        private int m_Score;
        private CBinarySearchTree m_AllChars;
        private List<Char> m_InsertionOrder;

        private String m_Status;

        public CScoreSystem()
        {
            ResetScores();
            m_Status = null;
         }

        public void ResetScores()
        {   m_Score = 0;
            m_Status = "All scores reset";
            m_AllChars = new CBinarySearchTree();
            m_InsertionOrder = new List<char>();

        }
        public CBinarySearchTree TheTree() { return m_AllChars; }

        public void ClearStatus() { m_Status = null; }
        public String GetStatus() { return m_Status; }

        public int GetScore() { return m_Score; }

        public void ScoreByNew(char c) {
            if (null == m_Status)
                m_Status = @"";

            if (m_AllChars.Add(c) == CBinarySearchTree.ErrorCode.Success)
            {
                m_Status += " Added(" + c +")";
                m_Score += c;
                m_InsertionOrder.Add(c);
            }
            else
            {
                m_Status += " Duplicate(" + c + ")";
                m_Score -= c;
            }
        }

        public void ScoreByFind(char c)
        {
            if (null == m_Status)
                m_Status = @"";

            if (m_AllChars.Find(c))
            {
                m_Score += c;
                m_Status += " Found(" + c + ")";
            }
            else
            {
                m_Score -= c;
                m_Status += " NotFound(" + c + ")";
            }
        }

        public char[] GetAllChars() 
        {
            return m_AllChars.GetAllInOrder();
        }

        public List<char> InsertionOrder { get { return m_InsertionOrder; }}
    }
}
