using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

// Our own library
using XNACS1Lib;

namespace AlphabetHunt
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class CFlyTreasureBox : CTreasureBox
    {
        private const String m_FlyTexture = @"Fly_";
        private String m_UseTexture;

        public CFlyTreasureBox(float xPos) : base(xPos)
        {
            float delta = 1.0f + (0.1f * CTreasureEngine.RandomNumber());
            m_TreasureObject.CenterY = CTreasureEngine.kFloorY * delta;
            m_TreasureObject.CenterY += 1.5f * CAlphabetHero.kHeroHeight;

            if (CTreasureEngine.RandomNumber() > 0.5f)
                m_TreasureObject.CenterY += 0.8f * CAlphabetHero.kHeroHeight;


            m_AlphaBox.CenterX = m_TreasureObject.CenterX + (kAlphaFraction * 0.8f * kBoxWidth);
            m_AlphaBox.CenterY = m_TreasureObject.CenterY + (kAlphaFraction * 0.8f * kBoxWidth);

            m_AlphaTexture = String.Concat(kCharArray[m_AlphaTexIndex]);

            int n = (int)(CTreasureEngine.RandomNumber() * 14.0f);
            m_UseTexture = String.Concat(m_FlyTexture, n);

            m_TreasureObject.Height = kBoxWidth;
            m_TreasureObject.Width = kBoxWidth;
            m_TreasureObject.Texture = m_UseTexture;

            m_AlphaBox.Width = kAlphaWidth;
            m_AlphaBox.Height = kAlphaHeight;
            m_AlphaBox.Texture = m_AlphaTexture;
        }

        protected override void TreasureScores(CScoreSystem score)
        {
            score.ScoreByNew(kCharArray[m_AlphaTexIndex]);
            XNACS1Base.PlayACue( "removefly");
        }

        protected override XNACS1Primitive AlphaBox()
        {
            return m_AlphaBox;
        }
    }
}
