using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

// Our own library
using XNACS1Lib;

namespace SwitchAndMod_Program
{
    class BackgroundStrip
    {
        // alternates between 7 pre-defined colors
        private const int PERIOD = 7;
        public const float STRIP_WIDTH = 10.0f;

            // Example number to color mapping
            // 
            // 0 = Color.LightCyan;
            // 1 = Color.LightBlue;
            // 2 = Color.LightCoral;
            // 3 = Color.LightGray;
            // 4 = Color.LightPink;
            // 5 = Color.LightSalmon;
            // 6 = Color.LightSeaGreen;
            //

        public BackgroundStrip()
        {
            Vector2 pos = new Vector2(-STRIP_WIDTH * 0.5f, XNACS1Base.World.WorldMax.Y * 0.5f);
            while (pos.X < XNACS1Base.World.WorldMax.X)
            {
                pos.X += STRIP_WIDTH;
                Color c = GetColor(pos.X);
                XNACS1Rectangle r = new XNACS1Rectangle(pos, STRIP_WIDTH, XNACS1Base.World.WorldMax.Y);
                r.CenterColor = c;
                r.OutsideColor = c;
            }
        }


        /// <summary>
        /// This method will be given the number of a color, and will return
        /// a Color object that C# can use to actually know what the Color is.
        /// For example, maybe you decide that "0" means "Light Cyan".  When the
        /// iColor variable has the value 0, you should set returnColorValue to be
        /// Color.LightCyan.
        /// You need to provide at least 7 distinct colors, that you can tell apart just by 
        /// looking at them (i.e., don't provide 7 ever-so-slightly-different shades of yellow :)  )
        /// The rest of the program uses 7 different colors, so you should be able to see your code
        /// in action.
        /// The rest of the program uses ONLY 7 different colors, so while you're welcome to add more, 
        /// you won't be able to see any difference.  What do you DO need to do is to provide for a 'default'
        /// color, so that if this code is run, and iColor has the value of (say) 200, you still
        /// return a default Color.  Make the default color different enough from the other 7 that
        /// if the code accidentally runs your code with a bad value for iColor, you'll be able to
        /// quickly and easily recognize that you're getting the default color back, instead
        /// of a 'normal' color.
        /// 
        /// 
        /// NOTE NOTE: In order to get full credit for this assignment, you need to demonstrate that you know
        /// how to use
        /// 1) if statements
        /// 2) if...else statements
        /// 3) switch statements
        /// 
        /// in order to get full credit for this assignment, you'll need to implement this code THREE times - 
        /// the first time, you'll use just 'if statements'. Run the program, make sure that everything works,
        /// then comment out that solution (but leave the code in, commented out, so that your instructor 
        /// can see it!), and for your second you'll write your code using if...else statements.  
        /// Run the program, make sure everything works, comment it out, and then solve this problem one more
        /// time, this time using a single switch statement
        /// 
        /// SUB-NOTE NOTE:  For all three solutions, you'll need to first solve the part of the
        /// homework assignment that deals with operators (located below).  That part of the homework
        /// has exactly one solution, and that solution will be used in all versions for this part.
        /// 
        /// You can find a list of the colors supported by C# in the online help that is
        /// part of Visual Studio, and also at http://msdn2.microsoft.com/en-us/library/ms534427.aspx
        /// (use the color name, like LightCyan, and ignore the stuff about =0xFFFE00FF, etc :)
        /// </summary>
        /// <param name="i"></param>
        /// <returns></returns>
        private Color GetColor(int iColor)
        {
            Color returnColorValue = Color.LightCyan;   // initialize

            ///////////////////////////////////////////////////////////////////
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:
            //
            // ==> THIS IS THE 'CONDITIONAL STATEMENTS' SECTION OF THE HOMEWORK <==
            // 
            ///////////////////////////////////////////////////////////////////

            // STUDENTS: YOUR SOLUTION USING 'IF STATEMENTS' SHOULD START HERE  //

            // blah
            // blah 
            // blah
            
            // STUDENTS: YOUR SOLUTION USING 'IF STATEMENTS' SHOULD END HERE  //


            // STUDENTS: YOUR SOLUTION USING 'IF/ELSE STATEMENTS' SHOULD START HERE  //

            // blah
            // blah 
            // blah

            // STUDENTS: YOUR SOLUTION USING 'IF/ELSE STATEMENTS' SHOULD END HERE  //


            // STUDENTS: YOUR SOLUTION USING 'SWITCH STATEMENTS' SHOULD START HERE  //
            switch (iColor)
            {
                case 0: returnColorValue = Color.LightCyan;
                    break;
                case 1: returnColorValue = Color.LightBlue;
                    break;
                case 2: returnColorValue = Color.LightCoral;
                    break;
                case 3: returnColorValue = Color.LightGray;
                    break;
                case 4: returnColorValue = Color.LightPink;
                    break;
                case 5: returnColorValue = Color.LightSalmon;
                    break;
                case 6: returnColorValue = Color.LightSeaGreen;
                    break;
                default: returnColorValue = Color.Black;
                    break;
            }
            // STUDENTS: YOUR SOLUTION USING 'SWITCH STATEMENTS' SHOULD END HERE  //




            ///////////////////////////////////////////////////////////////////
            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
            ///////////////////////////////////////////////////////////////////
            


            return returnColorValue;
        }


        public Color GetColor(float x)
        {
            int iColor = TranslateLocationToColor(x, STRIP_WIDTH, PERIOD);
            System.Diagnostics.Debug.Assert(iColor != -1, "ERROR: In your TranslateLocationToColor method, you need to store the answer in the iColor variable\nYou get this message if the iColor variable still has the value that we initialize it with (-1)");
            return GetColor(iColor);
        }



        /// <summary>
        /// This method will take a floating-point number (a number with a decimal
        /// component), and translate it to a whole number that represents which color
        /// to be used.  In order to keep this assignment simple, you don't have to worry
        /// about the colors themselves.  
        /// 
        /// The only thing you need to worry about is that any 
        /// xLocation values should be translated as follows.   NOTICE HOW THE VALUES
        /// THAT YOU'RE PRODUCING 'WRAP AROUND' TO ZERO AGAIN, SO THAT YOUR CODE WILL
        /// CYCLE THROUGH ALL THE COLORS!!!
        /// 
        /// If xLocation is:                                                Translate it to color #:
        /// > 0, and <= width                                               0 (zero)
        /// > width, and <= 2 * width                                       1
        /// > 2 * width, and <= 3 * width                                   2
        /// etc.                                                            etc.
        /// etc.                                                            etc.
        /// > (howManyColors - 1) * width, and <= howManyColors * width     (howManyColors - 1)
        /// > howManyColors * width, and <= (howManyColors + 1) * width     0 (zero - again!!)
        /// > (howManyColors+1) * width, and <= (howManyColors+2) * width   1 (again!!)
        /// 
        /// </summary>
        /// <param name="xLocation">This is the distance from the left edge of the screen.  0 is right on the left edge of the screen, and this value increases as you move right-ward</param>
        /// <param name="width">This tells you how wide each strip of color should be.</param>
        /// <param name="howManyColors">This tells you how many colors there are, in total</param>
        /// <returns>An integer that represents the color for this particular location.  0 (zero) is the first color</returns>
        private int TranslateLocationToColor(float xLocation, float width, int howManyColors)
        {
            // NOTE: You are being given this assignment specifically to learn about
            // operators, such as the division operator (including integer division)
            // and the modulus operator.  You are specifically NOT allowed to
            // solve this problem using a loop (i.e., you can't simply have your program
            // count up through the strips, and stop when it finds the strip that 
            // contains the xLocation

            int iColor = -1;

            ///////////////////////////////////////////////////////////////////
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:
            // 
            // ==> THIS IS THE 'OPERATOR' SECTION OF THE HOMEWORK <== 
            //
            ///////////////////////////////////////////////////////////////////
            
            // NOTE: You should figure out how to translate the xLocation, width, and howManyColors
            // to an integer that represents the number of the color (where color numbers start at zero)
            // IN ORDER FOR THIS TO WORK, you need to store that color number in the iColor variable!!

            // NOTE 2: Unlike the part about 'Conditional Operators' (above), you only need to solve
            // this once.  All of your solutions to the 'Conditional Operators' will use this one, single
            // solution to the 'Operators' section.

            ///////////////////////////////////////////////////////////////////
            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
            ///////////////////////////////////////////////////////////////////

            // EXAMPLE SOLUTION: 
            iColor = (((int)xLocation) / (int)width) % PERIOD; // TODO: Do we need to multiply x by the number of horizontal pixels?
            // EXAMPLE SOLUTION

            return iColor;
        }
    }
}


