// #define STUDENT_VERSION
#define INSTRUCTOR_VERSION

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

using XNACS1Lib;


namespace InsectsGarden_Program
{
    class InsectCollection
    {
        private const float CLOSE_TO_NET = 1.8f;
        private const int NUM_SCORES = 5;
        
        private InsectsGarden m_Garden;

        // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:
        
        ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////
        private Random m_Rand;

        private int m_NumInsectsSpotted;
        private int m_NumInsectCaught;

        private int[] m_Scores;
        private int m_TotalScore;
#endif  ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
        ///////////////////////////////////////////////////////////////////////

        // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:

        public InsectCollection(InsectsGarden garden)
        {

            m_Garden = garden;

            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

        ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////
            m_Rand = new Random();

            m_NumInsectsSpotted = 0;
            m_NumInsectCaught = 0;

            m_Scores = new int[NUM_SCORES];
            for (int i = 0; i < NUM_SCORES; i++)
                m_Scores[i] = -1;

            m_TotalScore = 0;
#endif  ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
        ///////////////////////////////////////////////////////////////////////

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:

        }

        /// <summary>
        /// This function is called (by the Garden) when a new insect is "spotted". 
        /// You generate a random position between
        /// 
        ///     0 to m_Garden.GardenWidth
        ///     0 to m_Garden.GardenHeight
        /// 
        /// and call the m_Garden.CreateInsectAt(x, y).
        /// </summary>
        /// <returns> a Vector2 </returns>
        public void PlaceANewInsect()
        {
            ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////
            double x = m_Rand.NextDouble() * m_Garden.GardenWidth;
            double y = m_Rand.NextDouble() * m_Garden.GardenHeight;
            m_NumInsectsSpotted++;

            m_Garden.CreateInsectAt(x, y);
#endif      ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
            ///////////////////////////////////////////////////////////////////////

            ///////////////////////////////////////////////////////////////////////
#if STUDENT_VERSION////////////////////////////////////////////////////////////

            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            // In order to let the rest of the game know where to create the new
            // insect, you'll need to call the 'CreateInsectAt' command.  If you wanted to 
            // create the new insect at the location of (20, 50) (so the X value of the
            // coordinate is 20 (meaning that the insect is 20 units of distance rightwards from
            // the left edge of the window), and the y is 50 (meaning that the insect is 
            // 50 units of distance down from the top edge of the window), you would do so
            // using the following command:
            //
            // m_Garden.CreateInsectAt(20.0, 50.0); // (Obviously, you need to un-comment this :)  )
            //
            // (Also remember that you can pass in variables, so if x is a variable with the value
            // 20.0,and y has the value 50.0, the following will do the same thing as the above example:
            //
            // m_Garden.CreateInsectAt(x, y); // (Obviously, you need to un-comment this :)  )
            //

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:

#endif  ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
            

        }

        /// <summary>
        /// This function will be called, and will determine if the player's net is
        /// touching the insect. You can assume if the two points are less than CLOSE_TO_NET distance
        /// away then it is considered as "caught".
        /// </summary>
        /// <param name="insectX"> insect's X position </param>
        /// <param name="insectY"> insect's Y position </param>
        /// <param name="netX"> the net's current X position </param>
        /// <param name="netY"> the net's current Y position </param>
        /// <param name="score"> the score for catching this insect </param>
        /// <returns></returns>
        public bool CatchInsect(double insectX, double insectY, double netX, double netY, int score)
        {
            double dx = insectX - netX;
            double dy = insectY - netY;
            double dist = Math.Sqrt((dx*dx) + (dy*dy));
            bool caught = (dist < CLOSE_TO_NET);

            if (caught)
            {
                ///////////////////////////////////////////////////////////////////////
                // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////


                m_NumInsectCaught++;
                if (m_NumInsectCaught <= NUM_SCORES)
                    m_Scores[m_NumInsectCaught-1] = score;

                m_TotalScore += score;
#endif  ///////////////////////////////////////////////////////////////////////
                // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
                ///////////////////////////////////////////////////////////////////////

                ///////////////////////////////////////////////////////////////////////
#if STUDENT_VERSION////////////////////////////////////////////////////////////
                
                // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

                // You will need to examine the 'score' parameter (described above)
                // in order to fully complete this assignment

                // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:

#endif  ///////////////////////////////////////////////////////////////////////
                ///////////////////////////////////////////////////////////////////////

            
            }

            return caught;
        }

        public String InsectsStatus()
        {
            ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////
            float percentCaught = 100.0f * (float)m_NumInsectCaught / (float)m_NumInsectsSpotted;
            String status =
                       "TotalSpotted:" + m_NumInsectsSpotted +
                       "  #Caught:" + m_NumInsectCaught +
                       "(" + percentCaught.ToString("F2") +
                       "%) Score:(Total=" + m_TotalScore +
                       " Avg=" + ((float)m_TotalScore / (float)m_NumInsectCaught).ToString("F2") +
                       ") First5Scores:[" + m_Scores[0] +
                                       " " + m_Scores[1] +
                                       " " + m_Scores[2] +
                                       " " + m_Scores[3] +
                                       " " + m_Scores[4] + "]";
            return status;

#endif  ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
            ///////////////////////////////////////////////////////////////////////

            ///////////////////////////////////////////////////////////////////////
#if STUDENT_VERSION////////////////////////////////////////////////////////////
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:
            // (You will want to replace this code that is being provided to you:)
            
            string myString = "Here is the first part";
            myString = myString + ", the second,";
            myString += " and the third";

            return myString;

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:

#endif  ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
        }

    }
}
