// #define STUDENT_VERSION
#define INSTRUCTOR_VERSION

using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using XNACS1Lib;

namespace InsectsGarden_Program
{
    class Insect
    {
        private const int TOTAL_INSECTS_PATTERN = 10;

        static private int m_ID = 0;
        static private int NextID()
        {
            m_ID = InsectsGarden.RandomInt(TOTAL_INSECTS_PATTERN);
            return m_ID;
        }

        private XNACS1Circle m_Circle;
        private int m_Id;

        public Insect(float x, float y)
        {
            m_Id = NextID();
            m_Circle = new XNACS1Circle(new Vector2(x, y), 1.0f);
            m_Circle.Texture = "Insect" + m_Id;
            m_Circle.VelocityX = InsectsGarden.RandomFloat(-0.2f, 0.2f);
            m_Circle.VelocityY = InsectsGarden.RandomFloat(-0.2f, 0.2f);
            m_Circle.ShouldTravel = true;
        }

        public Vector2 Position { get { return m_Circle.Center; } }

        public void UpdatePosition(float x, float y)
        {
            // update by velocity happens automatically with ShouldTravel set to true.
            m_Circle.Center += new Vector2(x, y);

            XNACS1Base.World.ClampAtWorldBound(m_Circle);
        }

        public int Score() { return (m_Id + 1) * 2; }

        public void KillInsect()
        {
            m_Circle.RemoveFromAutoDrawSet();
        }
    }
}
