#define INSTRUCTOR_VERSION
//#define STUDENT_VERSION

using System;
// using System.Collections.Generic; // 2005-Specific line
using System.Text;

namespace StarterFiles
{
    class PeriodicTable
    {
        Element[] m_theElements;

        public PeriodicTable()
        {
            m_theElements = new Element[113]; // I think there are 113....

            // create new elements here, as needed/desired:
            m_theElements[0] = new Element(1, "Hydrogen", "H", 1.0008);
            m_theElements[26] = new Element(27, "Cobalt", "Co", 58.9332);
            m_theElements[70] = new Element(71, "Lutetium", "Lu", 174.96);
            m_theElements[89] = new Element(90, "Protactinium", "Pa", 231.0359);

            // You'll need (at least) 6 more.
            // Pick them so that you can test your program

            // Don't worry about filling in more than 10, total, unless you
            // need more to test the program.
        }

        /// <summary>
        /// You might find this useful, since you're only required to fill 
        /// in 10 elements, and yet there are many more in table...
        /// </summary>
        /// <param name="atomicNum"></param>
        /// <returns>
        /// Return true if the table has data for a given element;
        /// return false otherwise
        /// </returns>
        public bool ElementHasData(int atomicNum)
        {
            ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////////

            atomicNum--;

            return atomicNum >= 0 && atomicNum < m_theElements.Length && m_theElements[atomicNum] != null;
#endif      ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
            ///////////////////////////////////////////////////////////////////////

            ///////////////////////////////////////////////////////////////////////
#if STUDENT_VERSION////////////////////////////////////////////////////////////////
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            return false;

            //
            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
#endif      ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
        }

        public int MaxAtomicNumber
        {
            get
            {
                ///////////////////////////////////////////////////////////////////////
                // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////////////

                return m_theElements.Length;

#endif          ///////////////////////////////////////////////////////////////////////
                // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
                ///////////////////////////////////////////////////////////////////////

                ///////////////////////////////////////////////////////////////////////
#if STUDENT_VERSION////////////////////////////////////////////////////////////////////
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            return 0;

            //
            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
#endif      ///////////////////////////////////////////////////////////////////////////
                ///////////////////////////////////////////////////////////////////////
            }
        }

        /// <summary>
        /// This is an "indexer"
        /// </summary>
        /// <param name="atomicNum">The atomic number of the element that we're
        /// accessing.  Note that Hydrogen, the first element, is 1 (not zero).
        /// This method will take care of any 're-mapping' that needs to happen</param>
        /// <returns></returns>
        public Element getElement(int atomicNum)
        {
            ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////////

            // first, validate the atomicNum parameter
            // if it's not valid (including the situation wherein the number
            // is valid, you didn't fill in the data for that element), then
            // return null.
            if (!ElementHasData(atomicNum))
                return null;

            // Otherwise, return the corresponding element.
            return m_theElements[--atomicNum];

#endif          ///////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
            ///////////////////////////////////////////////////////////////////////

            ///////////////////////////////////////////////////////////////////////
#if STUDENT_VERSION////////////////////////////////////////////////////////////////
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            return null;

            //
            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
#endif      ///////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
        }

        public void setElement(int atomicNum, Element e)
        {
            ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////////////

            atomicNum--;
            if (atomicNum >= 0 && atomicNum < m_theElements.Length)
                m_theElements[atomicNum] = e;

#endif          ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
            ///////////////////////////////////////////////////////////////////////

            ///////////////////////////////////////////////////////////////////////
#if STUDENT_VERSION////////////////////////////////////////////////////////////////////
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            // STUDENTS: IMPLEMENT THIS!!

            //
            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
#endif      ///////////////////////////////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////        
        }
    }
}
