#define INSTRUCTOR_VERSION
// #define STUDENT_VERSION

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;


// Our own library
using XNACS1Lib;

namespace SnakeAndLadder_Program
{
    class GameBoard
    {
        private GameCell[] m_Board;
        public const int INVALID_DESTINATION = -1;

        ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////

        private int m_TotalNumCells;
        private int m_MaxColumn;
        private int m_CurrentCell;

#endif  ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
        ///////////////////////////////////////////////////////////////////////


        public GameBoard(int numCells, int maxColumn)
        {
            ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////////

            m_TotalNumCells = numCells;
            m_MaxColumn = maxColumn;
            m_Board = new GameCell[numCells];

            InitializeBoard();
#endif      ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
            ///////////////////////////////////////////////////////////////////////
        }

        ///////////////////////////////////////////////////////////////////////////
#if STUDENT_VERSION////////////////////////////////////////////////////////////////

        public int getMaxColumn()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            return 0; // STUDENTS: IMPLEMENT THIS!!!

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

        public int getTotalCellsOnBoard()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            return 0; // STUDENTS: IMPLEMENT THIS!!!

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

        public void setPlayerCellByIndex(int newLocation)
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

        public GameCell getCellContainingPlayer()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            return null; // STUDENTS: IMPLEMENT THIS!!!

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

        public int getPlayerCellIndex()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            return 0; // STUDENTS: IMPLEMENT THIS!!!

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

        public GameCell getCell(int index)
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            return null;  // STUDENTS: IMPLEMENT THIS!!!

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

        public int getTotalGoldOnBoard()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            int total = 0;

            return total;

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

        public int createRandomSnakeOrLadder()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            return INVALID_DESTINATION;

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

#endif  ///////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////



        ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////

        public int getMaxColumn()
        {
            return m_MaxColumn;
        }

        public int getTotalCellsOnBoard()
        {
            return m_TotalNumCells;
        }

        public void setPlayerCellByIndex(int newLocation)
        {
            if (newLocation < 0 || newLocation >= m_TotalNumCells)
                m_CurrentCell = 0;
            else
                m_CurrentCell = newLocation;
        }
        public GameCell getCellContainingPlayer()
        {
            return m_Board[m_CurrentCell];
        }
        public int getPlayerCellIndex()
        {
            return m_CurrentCell;
        }
        public GameCell getCell(int index)
        {
            if (index < 0 || index >= m_TotalNumCells)
                return null;

            return m_Board[index];
        }

        public int getTotalGoldOnBoard()
        {
            int total = 0;

            for (int i = 0; i < m_TotalNumCells; i++)
                if (null != m_Board[i])
                    total += m_Board[i].getGoldPoints();

            return total;
        }

        public int createRandomSnakeOrLadder()
        {
            int dst = GetARandomCell();
            if (null == m_Board[m_CurrentCell])
            {
                m_Board[m_CurrentCell] = new GameCell(m_CurrentCell);
            }
            else
            {
                return INVALID_DESTINATION;
            }
            m_Board[m_CurrentCell].setDestination(dst);

            return dst;
        }

        private void InitializeBoard()
        {
            // not needed - C# will initialize arrays of references
            // to be null
            // for (int i = 0; i < m_TotalNumCells; i++)
            //    m_BoardUI[i] = null;

            const int NumSnakeLadder = 10;
            const int NumWithGold = 25;
            // const int GoldSize = 20;

            for (int l = 0; l < NumSnakeLadder; l++)
            {
                int cell = GetARandomCell();
                int dst = GetARandomCell();
                if (null == m_Board[cell])
                    m_Board[cell] = new GameCell(cell);
                m_Board[cell].setDestination(dst);
            }

            for (int g = 0; g < NumWithGold; g++)
            {
                int cell = GetARandomCell();
                if (null == m_Board[cell])
                    m_Board[cell] = new GameCell(cell);
                m_Board[cell].setGoldPoints(1); // We could generate a number randomly
                                                // but for now, we'll just go with 
                                                // 1 point per piece of gold
            }

            setPlayerCellByIndex(0);
        }

        private int GetARandomCell()
        {
            return (int)(SnakeAndLadder.RandomFloat(getTotalCellsOnBoard()));
        }

#endif  ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
        ///////////////////////////////////////////////////////////////////////
    }
}
