using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SnakeAndLadder_Program
{
    public class PlayStatus
    {
        private const float m_Speed = 0.2f;
        private int m_GotGold;
        private String m_PlayStatus;
        private Vector2 m_DestinationPos;
        private Vector2 m_Velocity;

        public PlayStatus()
        {
            Initialize();
        }

        public void Initialize()
        {
            m_GotGold = 0;
            m_PlayStatus = "";
            m_DestinationPos = new Vector2(0.0f, 0.0f);
            m_Velocity = new Vector2(0.0f, 0.0f);
        }
        public void InitStateFor(Vector2 from, Vector2 to)
        {
            m_DestinationPos = to;
            m_Velocity = to - from;
            m_Velocity.Normalize();
            m_Velocity *= m_Speed;
        }
        public bool ValidStatus(Vector2 pos)
        {
            bool valid = (m_Velocity.X != 0.0f) || (m_Velocity.Y != 0.0f);
            bool xNEq = (((int)pos.X) != ((int)m_DestinationPos.X));
            bool yNEq = (((int)pos.Y) != ((int)m_DestinationPos.Y));
            valid = valid && (xNEq || yNEq);
            return valid;
        }
        public int Gold
        {
            get { return m_GotGold; }
            set { m_GotGold = value; }
        }
        public String Status
        {
            get { return m_PlayStatus; }
            set { m_PlayStatus += value; }
        }
        public Vector2 Velocity
        {
            get { return m_Velocity; }
        }
    }
}