#define dotNet2_0

using System;


namespace Othello_Program
{
    class GamePiece
    {
        private int m_Player;

        public GamePiece(int p)
        {
            m_Player = p;
        }

        public void DrawPiece()
        {
#if dotNet2_0
            ConsoleColor clrOriginal;
#endif
            switch (m_Player)
            {
                case PlayBoard.WhitePlayer:
#if dotNet2_0
                    clrOriginal = Console.ForegroundColor;
                    Console.ForegroundColor = ConsoleColor.White;
#endif
                    Console.Write("W");
#if dotNet2_0
                    Console.ForegroundColor = clrOriginal;
#endif
                    break;
                case PlayBoard.BlackPlayer:
#if dotNet2_0
                    clrOriginal = Console.ForegroundColor;
                    Console.ForegroundColor = ConsoleColor.Black;
#endif
                    Console.Write("B");
#if dotNet2_0
                    Console.ForegroundColor = clrOriginal;
#endif
                    break;
            }
        }

        /// <summary>
        /// STUDENTS: This method will flip a given game piece.  If the piece is currently 
        /// owned by the BlackPlayer, then calling this method will cause the
        /// ownership to flip to the WhitePlayer.  Similar, if the piece is currently
        /// white, then calling FlipPiece will make it black
        /// </summary>
        public void FlipPiece()
        {
            if (m_Player == PlayBoard.WhitePlayer)
                m_Player = PlayBoard.BlackPlayer;
            else
                m_Player = PlayBoard.WhitePlayer;
        }

        /// <summary>
        /// STUDENTS: This method will flip a given game piece, so that the piece is now owned by
        /// the specified player (and the color will be adjusted so that the BlackPlayer's
        /// pieces are colored black, the WhitePlayer's pieces are colored white, etc)
        /// </summary>
        /// <param name="player">The number representing the player.  In the PlayToCell
        /// method, you should instead use BlackPlayer or WhitePlayer, instead of using
        /// 0 or 1 directly.  Failure to do so will result in the loss of points</param>
        public void FlipToPlayer(int player)
        {
            m_Player = player;
        }

        /// <summary>
        /// STUDENTS: This method will allow you (in PlayToCell, or HasValidPositions) to 
        /// determine if a given piece is owned by a specific player.  Note that this
        /// is different from figuring out if a given space is blank - see the 
        /// sample code in PlayToCell to see how to tell if a cell/square is empty.
        /// </summary>
        /// <param name="player">The number representing the player.  In the PlayToCell
        /// method, you should instead use BlackPlayer or WhitePlayer, instead of using
        /// 0 or 1 directly.  Failure to do so will result in the loss of points</param>
        /// <returns>true if this GamePiece object is owned by the specified
        /// player, false otherwise</returns>
        public bool IsPlayer(int player) { return (player == m_Player); }
    }
}