#define dotNet2_0 // There HAS to be something like this defined by Visual Studio itself....

using System;

namespace Othello_Program
{
    public class OthelloUI 
    {
        // Private application state
        // Location and size of the world
        private PlayBoard m_Board;

        public OthelloUI()
        {
            m_Board = new PlayBoard(8); // HINT: Change to being like 4x4 if you're looking to test
            // 'end-of-game' scenarios
        }

        public void Run()
        {
#if dotNet2_0
            Console.BackgroundColor = ConsoleColor.Blue;
            Console.ForegroundColor = ConsoleColor.DarkYellow;
#endif

            do
            {
                m_Board.DrawBoard();
                Console.WriteLine("{0}'s turn to move", m_Board.CurrentPlayerString());
                Console.WriteLine("What COLUMN would you like to place a piece in? (-1 to quit)");
                int col = getValidInputInt(-1, m_Board.getResolution() - 1);
                if (-1 == col)
                    break;

                Console.WriteLine("What ROW would you like to place a piece in? (-1 to quit)");
                int row = getValidInputInt(-1, m_Board.getResolution() - 1);
                if (-1 == row)
                    break;

                if (m_Board.PlayToCell(row, col))
                {
                    Console.WriteLine("{0} has moved; switching to {1}", m_Board.CurrentPlayerString(), m_Board.NextPlayerString());
                    m_Board.SwitchPlayer();
                }
                else
                {
                    Console.WriteLine("I'm sorry, but that's not a legal move - try again!");
                }

            } while (m_Board.HasValidPositions());

            if(!m_Board.HasValidPositions())
                Console.WriteLine("There are no more valid moves that {0} can make, so the game is over!", m_Board.CurrentPlayerString());
            // else, players elected to quit the game early

            Console.WriteLine("{0} has captured {1} pieces", m_Board.BlackPlayerString(), m_Board.BlackPlayerHas()); 
            Console.WriteLine("{0} has captured {1} pieces", m_Board.WhitePlayerString(), m_Board.WhitePlayerHas());
            Console.WriteLine("{0} has won the game!", m_Board.WinnerPlayerString());

            Console.WriteLine("Press <enter> to exit...");
            Console.ReadLine();
        }

        private int getValidInputInt(int min, int max)
        {
            int num;
            bool isNum = Int32.TryParse(Console.ReadLine(), out num);

            while (!isNum || num < min || num > max)
            {
                if (!isNum)
                    Console.WriteLine("You must type a number!");
                else if (num < min)
                    Console.WriteLine("You're not allowed to type less than {0} - you typed {1}", min, num);
                else if (num > max)
                    Console.WriteLine("You're not allowed to type greater than {0} - you typed {1}", max, num);
                isNum = Int32.TryParse(Console.ReadLine(), out num);
            }

            return num;
        }

        /*
        public bool KeepPlaying()
        {
            Console.WriteLine("Keep playing? (y/n)");
            bool retVal = 'n' != (char)Console.Read();
            Console.ReadLine();
            return retVal;
        }
        */

        public void DoPlayerTurn()
        {
            /*            if (XnaAssignmentBase.GamePad.Buttons.A == ButtonState.Pressed)
                        {
                            if (!m_ButtonPressed)
                            {
                                m_ButtonPressed = true;
                                int row = (int)m_Position.X;
                                int col = (int)m_Position.Y;
                                if ((row >= 0) && (row < BOARD_RESOLUTION) && (col >= 0) && (col < BOARD_RESOLUTION))
                                {
                                    if (m_Board.PlayToCell(row, col))
                                    {
                                        int w = m_Board.WhitePlayerHas();
                                        int b = m_Board.BlackPlayerHas();

                                        m_Status = "Player Pieces: White=" + w + "  Black=" + b;

                                        m_Board.SwitchPlayer();
                                        m_TopStatus = m_Board.CurrentPlayerString() + " piece turn";

                                        if (!m_Board.HasValidPositions())
                                        {
                                            m_Status += "   ****Player: " + m_Board.WinnerPlayerString() + " has won!";
                                        }

                                    }
                                    else
                                    {
                                        m_Status = "Position: (" + row + ", " + col + ") is not a valid move. Try again!";                            
                                    }
                                }
                                else
                                {
                                    m_Status = "Position: (" + row + ", " + col + ") is outside the game board. Try again!";
                                }
                            }
                
                        }
                        else
                        {
                            m_ButtonPressed = false;
                        }
             */
        }
    }
}
