using System;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using XNACS1Lib;

// If you haven't done so already, you should read the README.txt
// file, first

namespace BurstABubble_Program
{
    public class CircularThing : XNACS1Circle
    {

        public CircularThing()
            : this(0.0f, 0.0f, 1.0f)
        {
        }

        public CircularThing(float xPos, float yPos, float r)
            : this(xPos, yPos, r, Color.Magenta)
        {
        }

        public CircularThing(float xPos, float yPos, float r, Color outerColor)
        {
            CenterX = xPos;
            CenterY = yPos;
            Radius = r;
            m_ID = m_nextID++;
        }

        // protected: 
        //      Vector2 Center;  defined in super class (XNACS1Circle)
        //          // Accessing via: CenterX, and CenterY
        //
        //      float   Radius;  defined in super class (XNACS1Circle)
        //
        //      String  Texture; defined in super class (XNACS1Circle)
        //
        private static int m_nextID;
        protected int m_ID;

        public int ID
        {
            get { return m_ID; }
        }

        public float X
        {
            get { return Center.X; }
        }
        public float Y
        {
            get { return Center.Y; }
        }

        public bool OverLapsOtherThing(CircularThing other)
        {
            return Collided(other);
        }

        virtual protected String GetTexture() { return null; }
    }
}