using System;
using System.Collections.Generic;
using System.Text;

namespace Helpdesk
{
    class Helpdesk_MultipleQueues
    {
        // In the limit, one could use an array (or even a linked list) 
        // to keep track of many different queues of priorities
        private ListOfTickets lowPriority = new ListOfTickets();
        private ListOfTickets highPriority = new ListOfTickets(); // can also do this in the constructor

        public bool isEmpty()
        {
            return highPriority.isEmpty() && lowPriority.isEmpty();
        }

        public void AddTicket(string desc, Priority prio)
        {
            Ticket t = new Ticket(desc, prio);
            switch (prio)
            {
                case Priority.Low:
                    lowPriority.AddTicket(t);
                    break;
                case Priority.High:
                    highPriority.AddTicket(t);
                    break;
                default:
                    throw new ApplicationException("Somehow given a priority other than Low or High!");
            }
        }

        public Ticket RemoveNextTicket()
        {
            if (!highPriority.isEmpty())
            {
                return highPriority.RemoveNextTicket();
            }
            else if (!lowPriority.isEmpty())
            {
                return lowPriority.RemoveNextTicket();
            }
            else // nothing to remove
                return null;
        }

        public void PrintAll()
        {
            Console.WriteLine("Current Helpdesk tickets:");
            if (highPriority.isEmpty())
            {
                Console.WriteLine("\tNo high priority tasks");
            }
            else
            {
                Console.WriteLine("\tHigh Priority Tasks:");
                highPriority.PrintAll();
            }

            if (lowPriority.isEmpty())
            {
                Console.WriteLine("\tNo low priority tasks");
            }
            else
            {
                Console.WriteLine("\tLow Priority Tasks:");
                lowPriority.PrintAll();
            }
        }
    }
}
