using System;
using System.Collections.Generic;
using System.Text;

namespace ListOfToysBase
{
    public interface IListOfToysNode
    {
        IListOfToysNode Next { get; }
        float GetNodeSize { get; }
        void SetNodePosition(float x, float y);
    }

    public abstract class CListOfToysBase
    {

        protected void IterateAndCompute(float worldHeight, int count, IListOfToysNode first)
        {
            int n = 0;
            IListOfToysNode cur = first;
            while (null != cur)
            {
                float size = cur.GetNodeSize;
                float y = worldHeight - (2.2f * size);
                float x = ((count - n) * 2 * size) - size;
                cur.SetNodePosition(x, y);
                cur = GetNextNode(cur);
                n++;
            }
        }
        protected abstract IListOfToysNode GetNextNode(IListOfToysNode current);
    }
}