using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

// Our own library
using XNACS1Lib;

namespace CatchToyGame_Program
{
    class CatchBox : XNACS1Rectangle
    {
        // Constants
        private const float BOX_WIDTH = CatchToyGame.WORLD_WIDTH * 0.15f;
        public const float BOX_HEIGHT = CatchToyGame.WORLD_WIDTH * 0.05f;

        public const float BOX_INIT_POS_X = CatchToyGame.WORLD_WIDTH / 2.0f;
        public const float BOX_INIT_POS_Y = BOX_HEIGHT * 1.2f;

        public CatchBox()
            : base(new Vector2(BOX_INIT_POS_X, BOX_INIT_POS_Y), BOX_WIDTH, BOX_HEIGHT, "carton")
        { }


        public void MoveCatchBox(float deltaX)
        {
            CenterX += deltaX;
            XNACS1Base.World.ClampAtWorldBound(this);
        }

        public bool CaughtToy(ToyObject b)
        {
            return Collided(b);
        }
    }
}
