using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;


using XNACS1Lib;


namespace CatchToyGame_Program
{
    class ListOfToys
    {
        private List<ToyObject> m_ToyQueue;

        public ListOfToys()
        {
            m_ToyQueue = new List<ToyObject>();
        }

        public void AddToy()
        {
            ToyObject n = new ToyObject();      // create a new toy
            m_ToyQueue.Add(n);                  // add new toy to the queue
            IterateAndCompute();                // re-compute position for all existing toys
        }

        public ToyObject GetNextToy()
        {
            ToyObject n = null;
            
            if (m_ToyQueue.Count > 0)
            {    
                n = m_ToyQueue[0];
                m_ToyQueue.RemoveAt(0);
            }
            return n;
        }

        public void CurrentToyCount()
        {
            XNACS1Base.EchoToBottomStatus(@"Total toys in the queue: " + m_ToyQueue.Count);
        }


        private void IterateAndCompute()
        {
            for (int n=0; n<m_ToyQueue.Count; n++)
                m_ToyQueue[n].ComputePosition(m_ToyQueue.Count, n); // re-comptue each toy's current position
        }

 
    }
}
