using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

// Our own library
using XNACS1Lib;

namespace AlphabetHunt
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class CRoadTreasureBox : CTreasureBox
    {
        private const String kUseString = @"_Walk";

        public CRoadTreasureBox(float xPos) : base(xPos)
        {            
            float delta = 1.2f + (0.3f * CTreasureEngine.RandomNumber());
            m_TreasureObject.CenterY = CTreasureEngine.kFloorY * delta;

            m_AlphaBox.Center = m_TreasureObject.Center;
            m_AlphaTexture = String.Concat(kCharArray[m_AlphaTexIndex], kUseString);
            m_AlphaBox.RemoveFromAutoDrawSet();

            m_TreasureObject.Width = kBoxWidth;
            m_TreasureObject.Height = (kBoxWidth / kBitMapRatio);
            m_TreasureObject.Texture = m_AlphaTexture;
        }

        protected override XNACS1Primitive AlphaBox()
        {
            return m_TreasureObject;
        }
    }
}