using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

// Our own library
using XNACS1Lib;


namespace BlockBreaker_Program
{

    class BallSet
    {
        List<Ball> m_TheSet;

        private int m_TotalGenerated;

        public BallSet()
        {
            m_TheSet = new List<Ball>();
            m_TotalGenerated = 0;
        }

        public void ClearBalls()
        {
            int c = m_TheSet.Count;
            for (int i = c - 1; i >= 0; i--)
            {
                XNACS1Circle cir = m_TheSet[i].GetCircle;
                cir.RemoveFromAutoDrawSet();
                m_TheSet.RemoveAt(i);
            }
         
        }

        public void AddNewBall(Vector2 p)
        {
            int n = m_TheSet.Count;
            Ball b = new Ball(p, n);
            m_TheSet.Add(b);
            m_TotalGenerated++;
            XNACS1Base.PlayACue("NewBall");
        }

        public void Update(Paddle thePaddle, BlockSet blocks)
        {
            foreach (Ball b in m_TheSet)
            {
                b.Update();
                thePaddle.BounceBall(b);
                blocks.BreakBlocks(b);
            }

            int c = m_TheSet.Count;
            for (int i = c - 1; i >= 0; i--)
            {
                if (m_TheSet[i].Expired)
                    m_TheSet.RemoveAt(i);
            }
                
            String msg;
            msg = "Total Balls generated:" + m_TotalGenerated;
            if (m_TheSet.Count == 0)
            {
                msg += " Press-A to create a ball";
            }
            else
            {
                msg += " Current ball bouces: [";

                foreach (Ball b in m_TheSet)
                {
                    msg += " " + b.NumBounce;
                }
                msg += " ]";
            }
            XNACS1Base.EchoToBottomStatus(msg);
        }
    }
}