using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

// Our own library
using XNACS1Lib;

namespace BlockBreaker_Program
{
    class Paddle : Block
    {
        private const float PADDLE_INIT_POS_X = BlockBreaker.WORLD_WIDTH / 2.0f;
        private const float PADDLE_INIT_POS_Y = BlockBreaker.BLOCK_HEIGHT* 1.2f;
        private const float PADDLE_UNIT_SPEED = BlockBreaker.UNIT_SPEED * 0.7f;

        private const float DECAY = 0.8f;
        private const double VERY_SMALL = 0.00000001;

        private float m_CurrentSpeed;
        
        public Paddle() : base(PADDLE_INIT_POS_X, PADDLE_INIT_POS_Y, 0)
        {
            m_CurrentSpeed = 0.0f;
            m_Rec.Width *= 2.5f;
            m_Rec.Height *= 0.8f;

            m_Rec.OutsideColor = new Color(250, 120, 120);
            m_Rec.CenterColor = new Color(120, 120, 120);
            m_Rec.Texture = null;
            m_Rec.Label = "Paddle";
            m_Rec.LabelColor = Color.Pink;
        }

                
        public void MovePaddle(float deltaX)
        {
            m_CurrentSpeed *= DECAY;
            if (Math.Abs(m_CurrentSpeed) < VERY_SMALL)
                m_CurrentSpeed = 0.0f;

            m_CurrentSpeed += (deltaX * PADDLE_UNIT_SPEED);
            m_Rec.Center +=  new Vector2(m_CurrentSpeed, 0.0f);

            BoundCollideStatus status = XNACS1Base.World.ClampAtWorldBound(m_Rec);
        }

        public void BounceBall(Ball b) {

            if (CollideWithBall(b)) {
                XNACS1Base.PlayACue("Bounce");
                Vector2 v = b.Velocity;
                float speed = v.Length();

                v.X += m_CurrentSpeed;
                v.Y = (float)Math.Abs(v.Y);
                v.Normalize();
                v *= speed;
                    
                b.Velocity = v;

                Vector2 p = b.Position;
                p.Y = m_Rec.MaxBound.Y + b.Radius ;
                b.Position = p;
            }
        }
    }
}