using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

#region ___CODE_ADDEDE____ 
using XNACS1Lib;
#endregion

namespace SimpleXNA
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : XNACS1Base
    {
        #region A Position user can control
        XNACS1Circle m_Pt;    // A pointer
        #endregion

        #region The Ball
        Ball m_Ball;
        int m_Count; // for fun;
        #endregion


        protected override void InitializeWorld()
        {
            #region World Coordinate and initialize the ball
            World.SetWorldCoordinate(new Vector2(0f, 0f), 30f);      // Define the world coordinate
            m_Pt = new XNACS1Circle(new Vector2(5f, 2f), 1f);  // A simple circle for user control

            m_Ball = null;      // Initially no ball
            #endregion
        }

        protected override void UpdateWorld()
        {
            // Allows the game to exit
            if (GamePad.ButtonBackClicked())
                this.Exit();

            #region Manipluate the pointer
            m_Pt.Center += GamePad.ThumbSticks.Left;
            #endregion 

            #region Ball behavior
            
            // Create a new one if instructed by the user
            if (GamePad.ButtonAClicked()) {
                if (null != m_Ball)
                    m_Ball.DeleteBall();
                m_Ball = new Ball(m_Pt.Center, m_Count);
                m_Count++;
            }

            // Implement Ball behavior
            if (null != m_Ball)
            {
                m_Ball.Update();
                if (m_Ball.Expired)
                {
                    m_Ball.DeleteBall();
                    m_Ball = null;
                }
            }
            #endregion 
            
            #region Print some message for the user
            String msg;
            if (null != m_Ball)
            {
                if (m_Ball.Expired)
                    msg = "Ball falled off the window!";
                else
                    msg = "Ball inside the window Bounce=" +
                            m_Ball.NumBounce + " at:" + m_Ball.Position;
            }
            else
                msg = "No ball created";

            EchoToBottomStatus(msg);
            #endregion

            EchoToTopStatus("Left-ThumbStick or i-j-m-k to contorl the ball");
        }
    }
}