using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace SimpleXNA
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

#region __CODE_ADDED__: instance variable for the image and its position
        Texture2D sprite;   // represent the image as a 2D texture
        Vector2 pos;   // pos to draw the texture at
#endregion

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
#region __CODE_ADDED__: allocate memory and initialize pos
            pos = new Vector2();
            pos.X = 200.0f;   // Initial position of the image/texture
            pos.Y = 200.0f;
#endregion 

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

#region __CODE_ADDED__: load the image
           sprite = Content.Load<Texture2D>("MS"); 
                    // Notice: do not specify the ".jpg"
#endregion
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();


#region __CODE_ADDED__: Changing the pos of the image/texture

            // either from controller ... 
            if (GamePad.GetState(PlayerIndex.One).IsConnected)
            {
                Vector2 delta = GamePad.GetState(PlayerIndex.One).ThumbSticks.Left;
                pos += delta;
            }
            else
            {
                // or from the keyboard
                float dx = 0.0f, dy = 0.0f;
                if (Keyboard.GetState().IsKeyDown(Keys.Right))
                    dx += 1.0f;

                if (Keyboard.GetState().IsKeyDown(Keys.Left))
                    dx -= 1.0f;

                if (Keyboard.GetState().IsKeyDown(Keys.Up))
                    dy += 1.0f;

                if (Keyboard.GetState().IsKeyDown(Keys.Down))
                    dy -= 1.0f;

                pos.X += dx;
                pos.Y += dy;
            }
#endregion

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

#region __CODE_ADDED__: draw the image as a sprite (2D Texture)
            spriteBatch.Begin(); // Get ready to draw
            spriteBatch.Draw(sprite, pos, Color.White); // draw the image at position
            spriteBatch.End();   // Present the result to the screen
#endregion

            base.Draw(gameTime);
        }
    }
}
